/* Example code from Chinese Bulletin Forum board 
 *  The Arduino R3 UNO code can be adapted for other ASCII output string commands
 *  that have been customised to suit your purposes
 */

#include <SoftwareSerial.h>

const int powerPin = 4;
const int analogOutPin = 9;

SoftwareSerial HLK_V20_Serial(2, 3);

void setup()
{
  Serial.begin(115200);
  HLK_V20_Serial.begin(115200);
  pinMode(powerPin, OUTPUT);
}

void loop()
{
  int outputValue = 0;
  String HLK_V20_feedback = "";
  
  while (HLK_V20_Serial.available()) {
    HLK_V20_feedback = HLK_V20_Serial.readString();        
    Serial.println(HLK_V20_feedback);
    delay(100);
  }

  if (HLK_V20_feedback.endsWith("openElectricfan") == 1) { // Arduino microcontroller looks for this command from its Serial data string 
    digitalWrite(powerPin, HIGH);
    Serial.println("Turn on the Fan");
  } else if (HLK_V20_feedback.endsWith("closElectricfan") == 1) { //Arduino microcontroller looks for this command from its Serial data string 
    digitalWrite(powerPin, LOW);
    Serial.println("Turn off the Fan");
  } else  if (HLK_V20_feedback.endsWith("AdjustGearmin") == 1) { //Arduino microcontroller looks for this command from its Serial data string 
    outputValue = map(1, 0, 3, 0, 1023);
    analogWrite(analogOutPin, outputValue);
    Serial.print(outputValue);
    Serial.println("The Fan speed has been adjusted to Minimum");
  } else if (HLK_V20_feedback.endsWith("AdjustGearmax") == 1) {
    outputValue = map(3, 0, 3, 0, 1023);
    analogWrite(analogOutPin, outputValue);
    Serial.print(outputValue);
    Serial.println("The Fan speed has been adjusted to Maximum");
  }
}
