// Working code sketch to directly connect an ESP8266 12E module to a HiLink V20 Speech Recognition Device
// Buffer to store incoming commands from serial port
String inData;

void setup() {
    Serial.begin(115200);
    // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED_BUILTIN, OUTPUT);
    Serial.println("Serial connection has started, waiting for instructions...");
}

void loop() {
    while (Serial.available() > 0)
    {
        char received = Serial.read();
        inData += received; 

        // Process message when new line character is recieved
        if (received == '\n')
        {
            Serial.print("Arduino Received: ");
            Serial.print(inData);

            if(inData == "EF\n"){ // Test Example to capture "Turn on Cooling" voice command: Represented as Hex ASCII is 45 46 0A
              Serial.println("Cooling has been switched on");
              digitalWrite(LED_BUILTIN, HIGH);   // turn the LED on (HIGH is the voltage level)
              delay(1000);                       // wait for a second
              digitalWrite(LED_BUILTIN, LOW);    // turn the LED off by making the voltage LOW
            }   
            if(inData == "VW\n"){ //Example "Shut the Gate" : Represented as Hex ASCII is 56 57 0A
              Serial.println("The gate is closing");
            }  
            
            inData = ""; // Clear the received buffer
        }
    }
}
