#ifndef INC_UNI_NLU_CONTENT_H_
#define INC_UNI_NLU_CONTENT_H_

typedef struct {
  uni_u32 key_word_hash_code; /* 存放识别词汇对应的hashcode */
  uni_u8  nlu_content_str_index; /* 存放nlu映射表中的索引，实现多个识别词汇可对应同一个nlu，暂支持256条，如果不够换u16 */
  char    *hash_collision_orginal_str /* 类似Java String equal，当hash发生碰撞时，赋值为识别词汇，否则设置为NULL */;
} uni_nlu_content_mapping_t;

enum {
  eCMD_wakeup_uni,
  eCMD_exitUni,
  eCMD_LightsON,
  eCMD_LightsOFF,
  eCMD_DelayOn,
  eCMD_DelayOff,
  eCMD_TurnON,
  eCMD_TurnOFF,
  eCMD_TurnONCool,
  eCMD_TurnOffCool,
  eCMD_TurnONHeat,
  eCMD_TurnOFFHeat,
  eCMD_TurnOnAlarm,
  eCMD_TurnOffAlarm,
  eCMD_TurnOnDoor,
  eCMD_TurnOffDoor,
  eCMD_Latchon,
  eCMD_Latchoff,
  eCMD_SerialLatchON,
  eCMD_SerialLatchOFF,
  eCMD_OpenGate,
  eCMD_GateClose,
  eCMD_GateShut,
  eCMD_volumeUpUni,
  eCMD_volumeDownUni,
  eCMD_volumeMaxUni,
  eCMD_volumeMidUni,
  eCMD_SwitchON,
  eCMD_SwitchOFF,
  eCMD_RobotFWD,
  eCMD_RobotREV,
  eCMD_RobotL,
  eCMD_RobotR,
  eCMD_RobotStop,
  eCMD_RobotBack,
  eCMD_SelfDestruct,
  eCMD_SelfAbort,
  eCMD_OutFive,
  eCMD_OutTen,
  eCMD_OutTwenty,
  eCMD_OutThirty,
  eCMD_OutForty,
  eCMD_OutFifty,
  eCMD_OutSixty,
  eCMD_OutSeven,
  eCMD_OutEight,
  eCMD_OutNine,
  eCMD_OutNineFive,
  eCMD_OutHund,
  eCMD_OutOFF,
  eCMD_Name,
  eCMD_Upgrade,
  eCMD_OV,
  eCMD_CV,
  eCMD_ASP,
  eCMD_DSP,
  eCMD_AS,
  eCMD_DS,
  eCMD_AXF,
  eCMD_DEF,
};

const char* const g_nlu_content_str[] = {
[eCMD_wakeup_uni] = "{\"asr\":\"hello robot\",\"cmd\":\"wakeup_uni\",\"pcm\":\"[103, 104]\"}",
[eCMD_exitUni] = "{\"asr\":\"goodbye\",\"cmd\":\"exitUni\",\"pcm\":\"[106]\"}",
[eCMD_LightsON] = "{\"asr\":\"turn on the lights\",\"cmd\":\"LightsON\",\"pcm\":\"[108]\"}",
[eCMD_LightsOFF] = "{\"asr\":\"turn off the lights\",\"cmd\":\"LightsOFF\",\"pcm\":\"[109]\"}",
[eCMD_DelayOn] = "{\"asr\":\"turn off the lights after an hour\",\"cmd\":\"DelayOn\",\"pcm\":\"[110]\"}",
[eCMD_DelayOff] = "{\"asr\":\"turn on the lights after an hour\",\"cmd\":\"DelayOff\",\"pcm\":\"[110]\"}",
[eCMD_TurnON] = "{\"asr\":\"turn on air conditioner\",\"cmd\":\"TurnON\",\"pcm\":\"[111]\"}",
[eCMD_TurnOFF] = "{\"asr\":\"turn off air conditioner\",\"cmd\":\"TurnOFF\",\"pcm\":\"[112]\"}",
[eCMD_TurnONCool] = "{\"asr\":\"turn on cooling\",\"cmd\":\"TurnONCool\",\"pcm\":\"[113]\"}",
[eCMD_TurnOffCool] = "{\"asr\":\"turn off cooling\",\"cmd\":\"TurnOffCool\",\"pcm\":\"[114]\"}",
[eCMD_TurnONHeat] = "{\"asr\":\"turn on heating\",\"cmd\":\"TurnONHeat\",\"pcm\":\"[115]\"}",
[eCMD_TurnOFFHeat] = "{\"asr\":\"turn off heating\",\"cmd\":\"TurnOFFHeat\",\"pcm\":\"[116]\"}",
[eCMD_TurnOnAlarm] = "{\"asr\":\"alarm activate\",\"cmd\":\"TurnOnAlarm\",\"pcm\":\"[117]\"}",
[eCMD_TurnOffAlarm] = "{\"asr\":\"alarm deactivate\",\"cmd\":\"TurnOffAlarm\",\"pcm\":\"[118]\"}",
[eCMD_TurnOnDoor] = "{\"asr\":\"open the garage door\",\"cmd\":\"TurnOnDoor\",\"pcm\":\"[119]\"}",
[eCMD_TurnOffDoor] = "{\"asr\":\"close the door\",\"cmd\":\"TurnOffDoor\",\"pcm\":\"[120]\"}",
[eCMD_Latchon] = "{\"asr\":\"lock\",\"cmd\":\"Latchon\",\"pcm\":\"[121]\"}",
[eCMD_Latchoff] = "{\"asr\":\"unlock\",\"cmd\":\"Latchoff\",\"pcm\":\"[122]\"}",
[eCMD_SerialLatchON] = "{\"asr\":\"remote latch lock\",\"cmd\":\"SerialLatchON\",\"pcm\":\"[123]\"}",
[eCMD_SerialLatchOFF] = "{\"asr\":\"remote latch unlock\",\"cmd\":\"SerialLatchOFF\",\"pcm\":\"[124]\"}",
[eCMD_OpenGate] = "{\"asr\":\"open gate\",\"cmd\":\"OpenGate\",\"pcm\":\"[125]\"}",
[eCMD_GateClose] = "{\"asr\":\"close gate\",\"cmd\":\"GateClose\",\"pcm\":\"[126]\"}",
[eCMD_GateShut] = "{\"asr\":\"shut gate\",\"cmd\":\"GateShut\",\"pcm\":\"[127]\"}",
[eCMD_volumeUpUni] = "{\"asr\":\"turn up the volume\",\"cmd\":\"volumeUpUni\",\"pcm\":\"[128]\"}",
[eCMD_volumeDownUni] = "{\"asr\":\"turn down the volume\",\"cmd\":\"volumeDownUni\",\"pcm\":\"[128]\"}",
[eCMD_volumeMaxUni] = "{\"asr\":\"turn maximum volume\",\"cmd\":\"volumeMaxUni\",\"pcm\":\"[128]\"}",
[eCMD_volumeMidUni] = "{\"asr\":\"turn medium volume\",\"cmd\":\"volumeMidUni\",\"pcm\":\"[128]\"}",
[eCMD_SwitchON] = "{\"asr\":\"switch it on\",\"cmd\":\"SwitchON\",\"pcm\":\"[129]\"}",
[eCMD_SwitchOFF] = "{\"asr\":\"off switch\",\"cmd\":\"SwitchOFF\",\"pcm\":\"[130]\"}",
[eCMD_RobotFWD] = "{\"asr\":\"robot forward\",\"cmd\":\"RobotFWD\",\"pcm\":\"[]\"}",
[eCMD_RobotREV] = "{\"asr\":\"robot reverse\",\"cmd\":\"RobotREV\",\"pcm\":\"[]\"}",
[eCMD_RobotL] = "{\"asr\":\"robot left\",\"cmd\":\"RobotL\",\"pcm\":\"[]\"}",
[eCMD_RobotR] = "{\"asr\":\"robot right\",\"cmd\":\"RobotR\",\"pcm\":\"[]\"}",
[eCMD_RobotStop] = "{\"asr\":\"robot stop\",\"cmd\":\"RobotStop\",\"pcm\":\"[131]\"}",
[eCMD_RobotBack] = "{\"asr\":\"robot back\",\"cmd\":\"RobotBack\",\"pcm\":\"[132]\"}",
[eCMD_SelfDestruct] = "{\"asr\":\"destruct\",\"cmd\":\"SelfDestruct\",\"pcm\":\"[133]\"}",
[eCMD_SelfAbort] = "{\"asr\":\"abort\",\"cmd\":\"SelfAbort\",\"pcm\":\"[134]\"}",
[eCMD_OutFive] = "{\"asr\":\"five percent output\",\"cmd\":\"OutFive\",\"pcm\":\"[135]\"}",
[eCMD_OutTen] = "{\"asr\":\"ten percent output\",\"cmd\":\"OutTen\",\"pcm\":\"[136]\"}",
[eCMD_OutTwenty] = "{\"asr\":\"twenty percent output\",\"cmd\":\"OutTwenty\",\"pcm\":\"[137]\"}",
[eCMD_OutThirty] = "{\"asr\":\"thirty percent output\",\"cmd\":\"OutThirty\",\"pcm\":\"[138]\"}",
[eCMD_OutForty] = "{\"asr\":\"forty percent output\",\"cmd\":\"OutForty\",\"pcm\":\"[139]\"}",
[eCMD_OutFifty] = "{\"asr\":\"fifty percent output\",\"cmd\":\"OutFifty\",\"pcm\":\"[140]\"}",
[eCMD_OutSixty] = "{\"asr\":\"sixty percent output\",\"cmd\":\"OutSixty\",\"pcm\":\"[141]\"}",
[eCMD_OutSeven] = "{\"asr\":\"seventy percent output\",\"cmd\":\"OutSeven\",\"pcm\":\"[142]\"}",
[eCMD_OutEight] = "{\"asr\":\"eighty percent output\",\"cmd\":\"OutEight\",\"pcm\":\"[143]\"}",
[eCMD_OutNine] = "{\"asr\":\"ninety percent output\",\"cmd\":\"OutNine\",\"pcm\":\"[143]\"}",
[eCMD_OutNineFive] = "{\"asr\":\"ninety five percent output\",\"cmd\":\"OutNineFive\",\"pcm\":\"[144]\"}",
[eCMD_OutHund] = "{\"asr\":\"one hundred percent output\",\"cmd\":\"OutHund\",\"pcm\":\"[143]\"}",
[eCMD_OutOFF] = "{\"asr\":\"zero percent output\",\"cmd\":\"OutOFF\",\"pcm\":\"[145]\"}",
[eCMD_Name] = "{\"asr\":\"computer voice\",\"cmd\":\"Name\",\"pcm\":\"[146]\"}",
[eCMD_Upgrade] = "{\"asr\":\"is upgrading supported\",\"cmd\":\"Upgrade\",\"pcm\":\"[147]\"}",
[eCMD_OV] = "{\"asr\":\"open valve\",\"cmd\":\"OV\",\"pcm\":\"[148]\"}",
[eCMD_CV] = "{\"asr\":\"close valve\",\"cmd\":\"CV\",\"pcm\":\"[149]\"}",
[eCMD_ASP] = "{\"asr\":\"activate spa pump\",\"cmd\":\"ASP\",\"pcm\":\"[150]\"}",
[eCMD_DSP] = "{\"asr\":\"deactivate spa pump\",\"cmd\":\"DSP\",\"pcm\":\"[151]\"}",
[eCMD_AS] = "{\"asr\":\"activate sprinkler\",\"cmd\":\"AS\",\"pcm\":\"[152]\"}",
[eCMD_DS] = "{\"asr\":\"deactivate sprinkler\",\"cmd\":\"DS\",\"pcm\":\"[153]\"}",
[eCMD_AXF] = "{\"asr\":\"activate exhaust fan\",\"cmd\":\"AXF\",\"pcm\":\"[154]\"}",
[eCMD_DEF] = "{\"asr\":\"deactivate exhaust fan\",\"cmd\":\"DEF\",\"pcm\":\"[155]\"}",
};

/*TODO perf sort by hashcode O(logN), now version O(N)*/
const uni_nlu_content_mapping_t g_nlu_content_mapping[] = {
  {1789473180U/*hello robot*/, eCMD_wakeup_uni, NULL},
  {574610034U/*beam me up*/, eCMD_wakeup_uni, NULL},
  {207022353U/*goodbye*/, eCMD_exitUni, NULL},
  {1341108609U/*see you later aligator*/, eCMD_exitUni, NULL},
  {3563303722U/*turn on the lights*/, eCMD_LightsON, NULL},
  {72565248U/*turn off the lights*/, eCMD_LightsOFF, NULL},
  {1488808339U/*turn off the lights after an hour*/, eCMD_DelayOn, NULL},
  {1689487677U/*turn on the lights after an hour*/, eCMD_DelayOff, NULL},
  {766555508U/*turn on air conditioner*/, eCMD_TurnON, NULL},
  {1484192862U/*turn off air conditioner*/, eCMD_TurnOFF, NULL},
  {3912542779U/*turn on cooling*/, eCMD_TurnONCool, NULL},
  {2067626789U/*turn off cooling*/, eCMD_TurnOffCool, NULL},
  {3756111412U/*turn on heating*/, eCMD_TurnONHeat, NULL},
  {1911195422U/*turn off heating*/, eCMD_TurnOFFHeat, NULL},
  {2509653474U/*alarm activate*/, eCMD_TurnOnAlarm, NULL},
  {2557329827U/*alarm deactivate*/, eCMD_TurnOffAlarm, NULL},
  {763032066U/*open the garage door*/, eCMD_TurnOnDoor, NULL},
  {1479682853U/*close the door*/, eCMD_TurnOffDoor, NULL},
  {3327275U/*lock*/, eCMD_Latchon, NULL},
  {3454525252U/*unlock*/, eCMD_Latchoff, NULL},
  {1279022497U/*remote latch lock*/, eCMD_SerialLatchON, NULL},
  {1036986938U/*remote latch unlock*/, eCMD_SerialLatchOFF, NULL},
  {1487762657U/*open gate*/, eCMD_OpenGate, NULL},
  {1153189936U/*open the gate*/, eCMD_OpenGate, NULL},
  {2174835187U/*close gate*/, eCMD_GateClose, NULL},
  {1479758914U/*close the gate*/, eCMD_GateClose, NULL},
  {3277230519U/*shut gate*/, eCMD_GateShut, NULL},
  {3376351750U/*shut the gate*/, eCMD_GateShut, NULL},
  {2353044971U/*turn up the volume*/, eCMD_volumeUpUni, NULL},
  {2166624609U/*volume up*/, eCMD_volumeUpUni, NULL},
  {2155108932U/*turn down the volume*/, eCMD_volumeDownUni, NULL},
  {3361574376U/*volume down*/, eCMD_volumeDownUni, NULL},
  {3248853789U/*turn maximum volume*/, eCMD_volumeMaxUni, NULL},
  {2785375514U/*maximum volume*/, eCMD_volumeMaxUni, NULL},
  {2543908802U/*turn medium volume*/, eCMD_volumeMidUni, NULL},
  {1559126565U/*medium volume*/, eCMD_volumeMidUni, NULL},
  {4067588360U/*switch it on*/, eCMD_SwitchON, NULL},
  {1651315275U/*switch on*/, eCMD_SwitchON, NULL},
  {3398911749U/*off switch*/, eCMD_SwitchOFF, NULL},
  {3398911749U/*off switch*/, eCMD_SwitchOFF, "off switch"},
  {2056228623U/*robot forward*/, eCMD_RobotFWD, NULL},
  {2439981391U/*forward robot*/, eCMD_RobotFWD, NULL},
  {3833220908U/*robot reverse*/, eCMD_RobotREV, NULL},
  {241082284U/*reverse robot*/, eCMD_RobotREV, NULL},
  {2387548157U/*robot left*/, eCMD_RobotL, NULL},
  {656129297U/*left robot*/, eCMD_RobotL, NULL},
  {1005209830U/*robot right*/, eCMD_RobotR, NULL},
  {2422356838U/*right robot*/, eCMD_RobotR, NULL},
  {2387771384U/*robot stop*/, eCMD_RobotStop, NULL},
  {3540994U/*stop*/, eCMD_RobotStop, NULL},
  {2387246301U/*robot back*/, eCMD_RobotBack, NULL},
  {2175786936U/*go backwards*/, eCMD_RobotBack, NULL},
  {1033925526U/*destruct*/, eCMD_SelfDestruct, NULL},
  {970124697U/*computer initiate self destruct sequence*/, eCMD_SelfDestruct, NULL},
  {92611376U/*abort*/, eCMD_SelfAbort, NULL},
  {2123882252U/*computer abort self destruct sequence*/, eCMD_SelfAbort, NULL},
  {1871154282U/*five percent output*/, eCMD_OutFive, NULL},
  {2193776543U/*ten percent output*/, eCMD_OutTen, NULL},
  {3629257547U/*twenty percent output*/, eCMD_OutTwenty, NULL},
  {2395444026U/*thirty percent output*/, eCMD_OutThirty, NULL},
  {3694326414U/*forty percent output*/, eCMD_OutForty, NULL},
  {3546156692U/*fifty percent output*/, eCMD_OutFifty, NULL},
  {1758975893U/*sixty percent output*/, eCMD_OutSixty, NULL},
  {2714546122U/*seventy percent output*/, eCMD_OutSeven, NULL},
  {1886088786U/*eighty percent output*/, eCMD_OutEight, NULL},
  {868160965U/*ninety percent output*/, eCMD_OutNine, NULL},
  {3725924737U/*ninety five percent output*/, eCMD_OutNineFive, NULL},
  {3171739752U/*one hundred percent output*/, eCMD_OutHund, NULL},
  {4221229492U/*zero percent output*/, eCMD_OutOFF, NULL},
  {3397678061U/*computer voice*/, eCMD_Name, NULL},
  {4223003326U/*what is your name*/, eCMD_Name, NULL},
  {2292579633U/*is upgrading supported*/, eCMD_Upgrade, NULL},
  {3184815162U/*open valve*/, eCMD_OV, NULL},
  {3009227112U/*close valve*/, eCMD_CV, NULL},
  {3647321073U/*activate spa pump*/, eCMD_ASP, NULL},
  {3179420048U/*deactivate spa pump*/, eCMD_DSP, NULL},
  {1393278843U/*activate sprinkler*/, eCMD_AS, NULL},
  {4068216252U/*deactivate sprinkler*/, eCMD_DS, NULL},
  {3010556784U/*activate exhaust fan*/, eCMD_AXF, NULL},
  {939996529U/*deactivate exhaust fan*/, eCMD_DEF, NULL},
};

#endif
